;; MoonIce/theme.jl
;; Sawfish theme file
;; created by GimpMill, with manual tweaking

(def-frame-class moon-button '((cursor . left_ptr))
   (bind-keys moon-button-keymap
      "Button1-Off" 'delete-window)
   (bind-keys moon-button-keymap
      "Button2-Off" 'iconify-window)
   (bind-keys moon-button-keymap
      "Button3-Off" 'popup-window-menu))

(require 'make-theme)

(let*
   (
    (font (get-font "-adobe-helvetica-bold-r-normal-*-12-*-*-*-p-*-iso8859-1"))
    (font-colors (list "black"
                       "black"))

      (title-width
	 (lambda (w)
	    (let
	       ((w-width (car (window-dimensions w))))
	       (max 0 (+ 20 (min (- w-width 55) (text-width (window-name w) font)))))))
      
      (fix-frame-attrs
	 (lambda (w)
	    (if (eq (window-get w 'current-frame-style) 'MoonIce)
	       (rebuild-frame w))))


;; These hacks were needed to get the theme right in an old version of
;; sawfish; uncomment them if it doesn't work for you (and the hooks in
;; the end of the file)
;      (frame-shade-style
;	 (lambda (w)
;	    (if (eq (window-get w 'current-frame-style) 'MoonIce)
;	       (set-frame-for-window w t 'shaped)
;	       )))

;      (frame-unfocus-style
;	 (lambda (w)
;	    (if
;	       (and (eq (window-get w 'current-frame-style) 'MoonIce)
;		  (eq (window-type w) 'focused)
;		  (not (window-get w 'shaded))
;		  )
;	       (set-frame-for-window w t 'default)
;	       )))

;      (frame-focus-style
;	 (lambda (w)
;	    (if
;	       (and (eq (window-get w 'current-frame-style) 'MoonIce)
;		  (or
;		     (eq (window-type w) 'default)
;		     (eq (window-type w) 'normal)
;		     )
;		  (not (window-get w 'shaded))
;		  )
;	       (set-frame-for-window w t 'focused)
;	       )))

      (patterns-alist
	 '(
	     ("Border-topleft"
		(inactive "Border-topleft.png")
		(focused "Border-topleft.png")
		(highlighted "Border-topleft.png")
		(clicked "Border-topleft.png")
		)
	     ("Border-top"
		(inactive "Border-top.png")
		(focused "Border-top.png")
		(highlighted "Border-top.png")
		(clicked "Border-top.png")
		)
	     ("Border-topright"
		(inactive "Border-topright.png")
		(focused "Border-topright.png")
		(highlighted "Border-topright.png")
		(clicked "Border-topright.png")
		)
	     ("Border-right"
		(inactive "Border-right.png")
		(focused "Border-right.png")
		(highlighted "Border-right.png")
		(clicked "Border-right.png")
		)
	     ("Border-bottomright"
		(inactive "Border-bottomright.png")
		(focused "Border-bottomright.png")
		(highlighted "Border-bottomright.png")
		(clicked "Border-bottomright.png")
		)
	     ("Border-bottom"
		(inactive "Border-bottom.png")
		(focused "Border-bottom.png")
		(highlighted "Border-bottom.png")
		(clicked "Border-bottom.png")
		)
	     ("Border-bottomleft"
		(inactive "Border-bottomleft.png")
		(focused "Border-bottomleft.png")
		(highlighted "Border-bottomleft.png")
		(clicked "Border-bottomleft.png")
		)
	     ("Border-left"
		(inactive "Border-left.png")
		(focused "Border-left.png")
		(highlighted "Border-left.png")
		(clicked "Border-left.png")
		)
	     
	     ("Close"
		(focused "Close.png")
		(highlighted "Close.png")
		(clicked "Close.png")
		(inactive "Close-inactive.png")
		)
	     ("Maximize"
		(focused "Maximize.png")
		(highlighted "Maximize.png")
		(clicked "Maximize.png")
		(inactive "Maximize-inactive.png")
		)
	     ("Title"
		(focused "Title.png")
		(highlighted "Title.png")
		(clicked "Title.png")
		(inactive "Title-inactive.png")
		)
	     )
	 )
      (frames-alist
	 `(
	     ("focused"
		(
		   (background . "Border-topleft")
		   (left-edge . -5)
		   (top-edge . -5)
		   (class . top-left-corner)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-top")
		   (left-edge . 0)
		   (right-edge . 0)
		   (top-edge . -5)
		   (class . top-border)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-topright")
		   (right-edge . -5)
		   (top-edge . -5)
		   (class . top-right-corner)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-right")
		   (right-edge . -5)
		   (top-edge . 0)
		   (bottom-edge . 0)
		   (class . right-border)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-bottomright")
		   (right-edge . -5)
		   (bottom-edge . -5)
		   (class . bottom-right-corner)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-bottom")
		   (left-edge . 0)
		   (right-edge . 0)
		   (bottom-edge . -5)
		   (class . bottom-border)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-bottomleft")
		   (left-edge . -5)
		   (bottom-edge . -5)
		   (class . bottom-left-corner)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-left")
		   (left-edge . -5)
		   (top-edge . 0)
		   (bottom-edge . 0)
		   (class . left-border)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Close")
		   (left-edge . -5)
		   (top-edge . -23)
		   (class . moon-button)
		   (x-justify . left)
		   (y-justify . center)
		   )
		(
		   (background . "Maximize")
		   (left-edge . ,(lambda (w) (+ (title-width w) 15)))
		   (top-edge . -23)
		   (class . maximize-button)
		   (x-justify . left)
		   (y-justify . center)
		   )
		(
		   (background . "Title")
		   (left-edge . 15)
		   (width . ,(lambda (w) (title-width w)))
		   (top-edge . -23)
		   (class . title)
		   (text . window-name)
		   (font . ,font)
		   (x-justify . center)
		   (y-justify . center)
		   (foreground . "#000000")
		   )
		)
	     ("normal"
		(
		   (background . "Border-topleft")
		   (left-edge . -5)
		   (top-edge . -5)
		   (class . top-left-corner)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-top")
		   (left-edge . 0)
		   (right-edge . 0)
		   (top-edge . -5)
		   (class . top-border)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-topright")
		   (right-edge . -5)
		   (top-edge . -5)
		   (class . top-right-corner)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-right")
		   (right-edge . -5)
		   (top-edge . 0)
		   (bottom-edge . 0)
		   (class . right-border)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-bottomright")
		   (right-edge . -5)
		   (bottom-edge . -5)
		   (class . bottom-right-corner)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-bottom")
		   (left-edge . 0)
		   (right-edge . 0)
		   (bottom-edge . -5)
		   (class . bottom-border)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-bottomleft")
		   (left-edge . -5)
		   (bottom-edge . -5)
		   (class . bottom-left-corner)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-left")
		   (left-edge . -5)
		   (top-edge . 0)
		   (bottom-edge . 0)
		   (class . left-border)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Close")
		   (left-edge . -5)
		   (top-edge . -23)
		   (class . moon-button)
		   (x-justify . left)
		   (y-justify . center)
		   )
		(
		   (background . "Maximize")
		   (left-edge . ,(lambda (w) (+ (title-width w) 15)))
		   (top-edge . -23)
		   (class . maximize-button)
		   (x-justify . left)
		   (y-justify . center)
		   )
		(
		   (background . "Title")
		   (left-edge . 15)
		   (width . ,(lambda (w) (title-width w)))
		   (top-edge . -23)
		   (class . title)
		   (text . window-name)
		   (font . ,font)
		   (x-justify . center)
		   (y-justify . center)
		   (foreground . "#000000")
		   )
		)
	     ("shaped"
		(
		   (background . "Close")
		   (left-edge . -5)
		   (top-edge . -23)
		   (class . moon-button)
		   (x-justify . left)
		   (y-justify . center)
		   )
		(
		   (background . "Maximize")
		   (left-edge . ,(lambda (w) (+ (title-width w) 15)))
		   (top-edge . -23)
		   (class . maximize-button)
		   (x-justify . left)
		   (y-justify . center)
		   )
		(
		   (background . "Title")
		   (left-edge . 15)
		   (width . ,(lambda (w) (title-width w)))
		   (top-edge . -23)
		   (class . title)
		   (text . window-name)
		   (font . ,font)
		   (x-justify . center)
		   (y-justify . center)
		   (foreground . "#000000")
		   )
		)
	     ("transient"
		(
		   (background . "Border-topleft")
		   (left-edge . -5)
		   (top-edge . -5)
		   (class . top-left-corner)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-top")
		   (left-edge . 0)
		   (right-edge . 0)
		   (top-edge . -5)
		   (class . top-border)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-topright")
		   (right-edge . -5)
		   (top-edge . -5)
		   (class . top-right-corner)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-right")
		   (right-edge . -5)
		   (top-edge . 0)
		   (bottom-edge . 0)
		   (class . right-border)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-bottomright")
		   (right-edge . -5)
		   (bottom-edge . -5)
		   (class . bottom-right-corner)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-bottom")
		   (left-edge . 0)
		   (right-edge . 0)
		   (bottom-edge . -5)
		   (class . bottom-border)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-bottomleft")
		   (left-edge . -5)
		   (bottom-edge . -5)
		   (class . bottom-left-corner)
		   (x-justify . center)
		   (y-justify . center)
		   )
		(
		   (background . "Border-left")
		   (left-edge . -5)
		   (top-edge . 0)
		   (bottom-edge . 0)
		   (class . left-border)
		   (x-justify . center)
		   (y-justify . center)
		   )
		)
	     ("shaped-transient"
		)
	     ("unframed"
		)
	     )
	 )
      (mapping-alist
	 '(
	     (default . "normal")
	     (transient . "transient")
	     (shaped . "shaped")
	     (shaped-transient . "shaped-transient")
	     (unframed . "nil")
	     (focused . "focused")
	     )
	 )
      
      (theme-name 'MoonIce)
      )
   
   (add-frame-style theme-name 
      (make-theme patterns-alist frames-alist mapping-alist)
      )

   (when 
      (boundp 'mark-frame-style-editable)
      (mark-frame-style-editable theme-name)
      )

   (call-after-property-changed 'WM_NAME fix-frame-attrs)
   
   ;(add-hook 'focus-in-hook frame-focus-style t)
   ;(add-hook 'focus-out-hook frame-unfocus-style t)
   ;(add-hook 'shade-window-hook frame-shade-style)
   )
